
TYPO3.Flow - Feature # 42176

Work Package # 45013 (Resolved): Flexible plugin integration (TODO: Reviews)

Status: Resolved Priority: Should have
Author: Bastian Waidelich Category: MVC
Created: 2012-10-19 Assigned To: Marc Neuhaus
Updated: 2013-08-08 Due date:
PHP Version:
Has patch: No
Complexity: medium
Subject: Improve resolving of view
Description

Currently the resolution of a view class and the respective (fluid) template happens really early in the MVC dispatching and is not
extensible from the "outside".
The actual view & template shold only be resolved while rendering the action, so one can intervene in the action.
Besides view options (e.g. template/layout/widget root paths, view class name, ...) should be overridable via YAML.

Following steps are required:

    -  View::canRender() should not be called in ActionController::resolveView() (also remove it from API!)
    -  remove “NotFoundView”, instead the View should throw an exception while rendering (see #40888)
    -  documentation! (also include a section on how to use the template of a different action)

Views.yaml ( can be easily added through: https://review.typo3.org/#/c/11982/ ):

 1
 2# Change the template root path for all packages!
 3-
 4  options:
 5    templateRootPaths: ['resource://My.App/Private/Templates']
 6
 7# Add layout lookup path for all actions of the "Foo" controller in "Some.Package" 
 8-
 9  requestFilter: 'isPackage("Some.Package") && isController("Foo")'
10  options:
11    layoutRootPaths: ['resource://Other.Package/Private/Layouts', 'resource://Some.Package/Private/Layouts']
12
13# Use a custom view for all actions of "Some.Package" if the requested format is "json" 
14-
15  requestFilter: 'isPackage("Some.Package") && isFormat("json")'
16  viewObjectName: 'Other\Package\View\CustomView'

Note: The previous configuration format we envisioned was something like:

My:
  Package:
    viewClassName: TemplateView / TypoScriptView
    options:
      templateRootPath: resources://Other.Package/...
      layoutRootPath: ...
    controllers:
      'List':
        options:
           # ...
       widget:
         'TYPO3\TypoScript\ViewHelpers\Widget\Paginate':
           templateRootPath: ...

        actions:
          'some':
            #...

Related issues:
related to TYPO3.Flow - Bug # 40888: Add ViewNotFoundException Resolved 2012-09-13
related to TYPO3.Fluid - Feature # 33487: Configure from what package to use ... Closed 2012-01-27
related to TYPO3.Fluid - Feature # 39870: Allow configuration of template pat... Resolved 2012-08-16
related to TYPO3.Flow - Feature # 40857: When template is automatically retri... Resolved 2012-09-12
related to TYPO3.Flow - Task # 43930: Remove canRender() completely?! Needs Feedback2012-12-12
related to TYPO3.TypoScript - Feature # 44417: Enable multiple TypoScriptPath... Resolved 2013-01-09

Associated revisions
Revision 9f99c840 - 2012-12-10 17:26 - Bastian Waidelich

[BUGFIX] Throw ViewNotFoundException if view could not be resolved

This improves the resolving of views by removing the canRender()
checks from ActionController::resolveView as discussed in #42176.

Besides this skips the creation of the obsolete NotFoundView in favor
of throwing a ViewNotFoundException.

This also adds overdue unit tests for the ActionController.

Change-Id: I27cba20836d695e46fe355bd1e4168a6fd86eb76
Fixes: #40888
Fixes: #40857
Related: #42176
Releases: 1.2

Revision 6f03a9a4 - 2012-12-12 15:56 - Bastian Waidelich

[TASK] Remove API annotation from View::canRender()

With #40888 View::canRender() is no longer called from within
ActionController::resolveView().
As the framework no longer relies on that method to exist the
@api annotation is removed.
Besides this marks EmptyView deprecated.

Change-Id: Ia10809aed5829ee2ed2308965a0f87cfca6d182b
Related: #40888
Related: #42176
Releases: 1.2

Revision dc39b58d - 2013-08-05 15:42 - Marc Neuhaus 

[FEATURE] Allow view configuration via Views.yaml

This patch adds a new Configuration called ``Views.yaml``
to set/override various settings for Views, just
like the template path to use or controller options.

Example ``Views.yaml``::
-
      requestFilter: 'isPackage("My.Package")'
      viewClassName: 'TYPO3\TypoScript\View\TypoScriptView'
      options:
        typoScriptPathPattern: 'resource://My.Package/Private/TypoScripts'

Change I7596f6fc7f8349f3c43d05e6b5916b7946d412d5 in
Fluid takes care about this with rearranging the TemplateView.

Additionally this change introduces a dependency to TYPO3.Eel.

Change-Id: I93acc3ed3d9578a5d00d494b367aa7201138255b
Resolves: #42176
Releases: master

Revision 0346b3ef - 2013-08-09 14:49 - Karsten Dambekalns

[BUGFIX] Use @dev version of TYPO3.Eel

Change-Id: I5b860b36f70e34afa09a2ad5bd7ae693808a5f3f
Related: #42176
Releases: master

History
#1 - 2012-11-11 02:29 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16392

#2 - 2012-11-11 02:49 - Gerrit Code Review
Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16393

#3 - 2012-11-12 11:30 - Marc Neuhaus

I've created a basic WIP implementation and pushed it to gerrit.
So far it only works for ActionController, not Widgets, i've been thinking about how to 
configure Widgets and got the idea, that we should use the SubRequests Namespaces here
to make it as flexible and understandable as possible:

My:
  Package:
    controllers:
      MyController:
        actions:
          someAction:
            subrequests:
              widgetNamespace:
                Some:
                  Package:
                    controllers:
                      SomeWidgetController:
                        actions:
                          first:
                            options: ...

What i don' really like, is that this become quite long and verbose :/

#4 - 2012-11-12 23:42 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16392

#5 - 2012-11-13 00:05 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16393

#6 - 2012-11-13 00:58 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16392

#7 - 2012-11-13 02:18 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16393

2015-08-03 4/13

http://review.typo3.org/16393
http://review.typo3.org/16392
http://review.typo3.org/16393
http://review.typo3.org/16392
http://review.typo3.org/16393


#8 - 2012-11-17 01:52 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16392

#9 - 2012-11-19 15:47 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16392

#10 - 2012-11-25 22:43 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16393

#11 - 2012-11-27 23:50 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16392

#12 - 2012-12-03 02:14 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16392

#13 - 2012-12-10 13:13 - Karsten Dambekalns
- Target version changed from 2.0 beta 1 to 2.1

#14 - 2013-01-16 12:21 - Bastian Waidelich
- File Views.schema.yaml added

Hi Marc,

I've started adjusting your patch to the current version and tweaking the configuration format (attached you'll find a simplified YAML schema for it):

 1My:
 2  Package:
 3    viewClassName: 'My\Custom\View' # all views that are rendered in package "My.Package" 
 4    controllers:
 5      'My\Package\Controller\FooController':
 6        viewClassName: 'My\Custom\View' # all views that are rendered in FooController of package "My.Package" 
 7        actions:
 8          'index':
 9            viewClassName: 'My\Custom\View' # all views that are rendered in indexAction of FooController of package "My.Package" 
10    subRequests:
11      viewClassName: 'My\Custom\View' # all views that are rendered in sub requests of package "My.Package" 
12      controllers:
13        'Other\Package\Controller\BarController':
14          viewClassName: 'My\Custom\View' # all views that are rendered in BarController of package "Other.Package" and are sub requests
within "My.Package" 
15          actions:
16            'index':
17              viewClassName: 'TYPO3\Fluid\View\TemplateView' # all views that are rendered in indexAction of BarController of package
"Other.Package" and are sub requests within "My.Package" 

In order to make this really flexible though, the subRequests key need to be allowed under "PackageKey", "controller" and "action" recursively.
This leads to a very "expensive" check for each request, especially in nested requests.
For a simple widget requests (calling "SubPackage.SubController.SubAction" in a parent request "RootPackage.RootController.RootAction") those 12
paths would need to be checked and merged:

<RootPackage>.controllers.<RootController>.actions.<RootAction>.subRequests.controllers.<SubController>.actions.<SubAction>
<RootPackage>.controllers.<RootController>.actions.<RootAction>.subRequests.controllers.<SubController>
<RootPackage>.controllers.<RootController>.actions.<RootAction>.subRequests
<RootPackage>.controllers.<RootController>.subRequests.controllers.<SubController>.actions.<SubAction>
<RootPackage>.controllers.<RootController>.subRequests.controllers.<SubController>
<RootPackage>.controllers.<RootController>.subRequests
<RootPackage>.subRequests.controllers.<SubController>.actions.<Sub1Action>
<RootPackage>.subRequests.controllers.<SubController>
<RootPackage>.subRequests
<SubPackage>.controllers.<SubController>.actions.<SubAction>
<SubPackage>.controllers.<SubController>
<SubPackage>

for more nesting levels (e.g. widget within plugin within neos page) the number of checks increases exponentially.

The more I think about it the more I'm convinced that we need some kind of pattern syntax here, similar to the Policy.yaml pointcut expressions. It's all
about matching a certain request based on package, controller & action and possibly its parent request(s).

The question is: how can we make this deterministic, easy to comprehend and especially easy to override?

#15 - 2013-01-29 10:03 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#16 - 2013-01-31 15:31 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#17 - 2013-01-31 15:34 - Gerrit Code Review

2015-08-03 6/13

https://review.typo3.org/16392
https://review.typo3.org/16393


Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#18 - 2013-01-31 16:09 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#19 - 2013-01-31 16:12 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#20 - 2013-01-31 16:16 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#21 - 2013-01-31 16:31 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#22 - 2013-01-31 16:36 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#23 - 2013-01-31 16:39 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#24 - 2013-01-31 17:02 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#25 - 2013-01-31 17:08 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#26 - 2013-01-31 17:51 - Gerrit Code Review
Patch set 16 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#27 - 2013-02-01 09:19 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#28 - 2013-02-08 00:13 - Gerrit Code Review

Patch set 17 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#29 - 2013-02-08 09:55 - Gerrit Code Review

Patch set 18 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#30 - 2013-02-08 09:59 - Gerrit Code Review

Patch set 19 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#31 - 2013-02-22 10:20 - Bastian Waidelich

Update for devs watching this issue:
We decided to go for a DSL (domain specific language) – probably based on TYPO3 Eel – for the configuration format in order to reduce the amount
of configuration to write while increasing the flexibility massively. More details asap, stay tuned

#32 - 2013-03-06 13:52 - Gerrit Code Review

Patch set 20 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#33 - 2013-03-15 13:19 - Marc Neuhaus

We (Bastian, Sebastian and Me) just had a little Hangout about the Syntax we're going to use:

General Syntax:

-
  options: 
     layoutRootPath: ‘foo/bar’
     ...
  requestFilter: ‘...’
Available filters:

- isPackage()  1
- isController() 10
- isAction() 100
- isFormat() 1000
- mainRequest() 10000
- parentRequest() 100000

isPackage() || isPackage() => 1
isPackage() && parentRequest.isPackage() => 100001

→ Score wird NUR hochgezählt, wenn einzelner Key zutrifft! → bei OR werden nur die matchenden Teile gezählt.
→ aufsteigend sortieren.

Use cases:

Use case 1: “Change the layout of a package (in Flow)”

-
  options:
     layoutRootPath: ‘foo/bar’
  requestFilter: ‘’isPackage(‘Some.Package”) && isFormat(‘html’)”

Use case 2: “Add TypoScriptPaths to an TypoScriptView (e.g. Expose)”

-
  options: 
     layoutRootPath: ‘foo/bar’
  requestFilter: ‘’isPackage(‘TYPO3.Expose”)”

Use case 3: “Change the layout of a package only in a sub request (in Neos)”

-
  options: 
     layoutRootPath: ‘foo/bar’
  requestFilter: ‘’isPackage(‘Some.Package”) && isFormat(‘html’) && mainRequest.isPackage(‘TYPO3.Neos’)”

#34 - 2013-03-15 18:02 - Gerrit Code Review

Patch set 21 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#35 - 2013-03-16 00:45 - Gerrit Code Review

Patch set 22 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#36 - 2013-03-16 00:47 - Gerrit Code Review

Patch set 23 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#37 - 2013-03-17 01:18 - Gerrit Code Review

Patch set 24 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#38 - 2013-03-18 11:37 - Gerrit Code Review

Patch set 25 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#39 - 2013-03-18 15:01 - Marc Neuhaus
- % Done changed from 0 to 90
- Complexity set to medium

#40 - 2013-03-18 15:03 - Aske Ertmann
- Parent task set to #45013

#41 - 2013-03-26 23:17 - Gerrit Code Review

Patch set 26 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#42 - 2013-03-28 16:31 - Aske Ertmann
- Estimated time set to 120.00

#43 - 2013-03-28 18:27 - Gerrit Code Review

Patch set 27 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#44 - 2013-04-04 09:42 - Gerrit Code Review

Patch set 28 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#45 - 2013-04-04 09:48 - Gerrit Code Review

Patch set 29 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392
#46 - 2013-04-11 15:58 - Gerrit Code Review

Patch set 30 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#47 - 2013-04-12 15:50 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#48 - 2013-04-15 15:31 - Gerrit Code Review

Patch set 31 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#49 - 2013-04-15 15:42 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#50 - 2013-05-13 15:13 - Gerrit Code Review

Patch set 32 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#51 - 2013-05-13 15:13 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#52 - 2013-05-14 09:01 - Gerrit Code Review

Patch set 33 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#53 - 2013-05-21 13:28 - Robert Lemke
- Target version deleted (2.1)

#54 - 2013-06-05 12:21 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#55 - 2013-06-05 15:42 - Gerrit Code Review
Patch set 34 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#56 - 2013-06-05 22:42 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#57 - 2013-06-06 09:55 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#58 - 2013-06-10 22:21 - Gerrit Code Review

Patch set 35 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#59 - 2013-06-10 23:10 - Gerrit Code Review

Patch set 36 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#60 - 2013-06-11 11:36 - Gerrit Code Review

Patch set 37 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#61 - 2013-06-19 10:13 - Gerrit Code Review

Patch set 38 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#62 - 2013-06-25 21:40 - Gerrit Code Review

Patch set 39 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#63 - 2013-06-25 22:14 - Gerrit Code Review

Patch set 40 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#64 - 2013-06-25 22:53 - Gerrit Code Review
Patch set 16 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#65 - 2013-06-26 07:56 - Kay Strobach

will this ported to TYPO3 CMS as well? There is an extension called view made by Claus Due, which adds similar functionality :\

#66 - 2013-06-26 11:03 - Marc Neuhaus

This could be backported. Main issue/thing that would need to be discussed is, if Eel will be backported as well, or if the configuration will be done in
typoscript somehow.

#67 - 2013-07-31 12:55 - Gerrit Code Review

Patch set 41 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#68 - 2013-07-31 13:10 - Gerrit Code Review

Patch set 42 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#69 - 2013-08-05 15:23 - Gerrit Code Review

Patch set 17 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#70 - 2013-08-05 15:42 - Gerrit Code Review

Patch set 43 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16392

#71 - 2013-08-07 15:21 - Gerrit Code Review

Patch set 18 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/16393

#72 - 2013-08-08 11:07 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 90 to 100

Files
Views.schema.yaml 1.8 kB 2013-01-16 Bastian Waidelich
